package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.UserDictItem;
import com.sa.ibiz.demo.demo.service.UserDictItemService;
import com.sa.ibiz.demo.demo.service.dto.UserDictItemSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/userdictitem")
public class UserDictItemResource
{
	@Autowired
	private UserDictItemService service;


	@PostMapping(value = "/update")
	public ResponseEntity<UserDictItem> update(@Validated @RequestBody UserDictItem data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("用户词条[update]操作发生错误","UserDictItem",data.getUserdictitemid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/checkKey")
	public ResponseEntity<UserDictItem> checkKey(@Validated @RequestBody UserDictItem data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("用户词条[checkKey]操作发生错误","UserDictItem",data.getUserdictitemid().toString());
		return ResponseEntity.ok().body(data);
	}
	@GetMapping(value = "/{id}")
	public ResponseEntity<UserDictItem> get(@Validated @PathVariable String id){
		UserDictItem data=new UserDictItem();
		data.setUserdictitemid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("用户词条[get]操作发生错误","UserDictItem",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<UserDictItem> getDraft(@Validated @RequestBody UserDictItem data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("用户词条[getDraft]操作发生错误","UserDictItem","");
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<UserDictItem> create(@Validated @RequestBody UserDictItem data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("用户词条[create]操作发生错误","UserDictItem",data.getUserdictitemid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<UserDictItem> remove(@Validated @RequestBody UserDictItem data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("用户词条[remove]操作发生错误","UserDictItem",data.getUserdictitemid().toString());
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<UserDictItem>> searchDefaultPage(@Validated @RequestBody UserDictItemSearchFilter filter){
		Page<UserDictItem> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<UserDictItem>> listDefault(@Validated @RequestBody UserDictItemSearchFilter filter){
		List<UserDictItem> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
